var query = new TSqlQueryV2(T_SQLCNT_POOL.getSqlDatabase());
query.begin();
try {
  var ans = TMessageBox.question(this, this.ttr("Do you want to delete the selected item?"), '', '',
      [this.ttr('Delete')+':Yes:Yes:Error', this.ttr('Cancel')+':Cancel:Cancel:Normal']);
  if (ans != 'Yes') {
    return;
  }
  var mailDeleter = new TSqlDeleterV2;
  mailDeleter.setTable("pub_contacts");
  mailDeleter.setWhere(_.format("id IN (SELECT contcat_id FROM sys_user WHERE id = ({0}))", this.selectedItems()));
  query.deleteRow(mailDeleter);
  
  var mailError = query.lastError();
  if (mailError.isValid()) {
      throw mailError;
  }

  var userDeleter = new TSqlDeleterV2;
  userDeleter.setTable("sys_user");
  userDeleter.setWhere("id", this.selectedItems());
  query.deleteRow(userDeleter);

  var userError = query.lastError();
  if (userError.isValid()) {
      throw userError;
  }
  query.commit();
  this.alertOk(this.ttr("Data deleted"));
  this.refresh(true);
} catch (e) {
  query.rollback();
  this.alertError(this.ttr("Delete data failed!"));
  print(e);
}


/*---ACTION---
ICON: "times-circle"
LABEL: "Delete"
LABEL_ZHCN: "刪除"
LABEL_ZHTW: "刪除"
ACCEL: "Delete"
TOOLTIP: "Delete"
TOOLTIP_ZHCN: "删除"
TOOLTIP_ZHTW: "刪除"
PERMISSION: "sys-user-delete"
CHECKED: ""
GROUP: ""
STYLE: "size=small button_style=both"
LANG: "JavaScript"
STATUS: "Release"
VERSION: "1"
STATEHOOK: "if(this.selectedItems().length > 0 && !this.isDetailModified()){return 'enable'}else{return 'disable'}"
---ACTION---*/